Index: Commands.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Commands.cpp,v
retrieving revision 1.227
diff -u -p -b -r1.227 Commands.cpp
--- Commands.cpp	16 Jan 2005 00:58:16 -0000	1.227
+++ Commands.cpp	10 Apr 2005 22:43:18 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: Commands.cpp,v 1.227 2005/01/16 00:58:16 klas Exp $
+// $Id: Commands.cpp,v 1.248 2005/04/05 12:45:06 jockelundin Exp $
 //
 // Usage: Ftp commands and data transfer functions
 //
@@ -7,202 +7,69 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#define __COMMANDS_CPP__
-#define __NETINCLS__
-#define _STREAM_COMPAT
+#define COMMANDS_CPP
+#define NETINCLS
 #include "Commands.h"
 
-bool Commands::ftp_send(User *user, string message)
-{
-  int ret;
-  fd_set wfds;
-  struct timeval tv;
-
-  if(user->socket_id < 0)
-  {
-    user->logged_in = LOGGED_OUT;
-    return(false);
-  }
-  FD_ZERO(&wfds);
-  FD_SET(user->socket_id, &wfds);
-  tv.tv_sec = 1;
-  tv.tv_usec = 0;
-
-  sem_wait(&user->user_lock);
-  if(!select(user->socket_id + 1, NULL, &wfds, NULL, &tv))
-  {
-    user->logged_in = LOGGED_OUT;
-    sem_post(&user->user_lock);
-    return(false);
-  }
-  message += "\r\n";
-#ifdef USE_TLS
-  if(user->settings.test(TLS_ENABLED))
-    ret = gnutls_record_send(user->ctrl_session, static_cast<const void*>(message.c_str()), message.size());
-  else
-#endif // USE_TLS
-    ret = write(user->socket_id, static_cast<const void*>(message.c_str()), message.size());
-
-  sem_post(&user->user_lock);
-  if(ret < 0)
-  {
-    logging->log_this(3, TYPE_INFO, "write to socket " + util.itos(user->socket_id) + " failed: %m"); // I think %m should work here as well.. maybe?
-    return(false);
-  }
-  return(true);
-}
-
-bool Commands::ftp_receive(User *user, string &message)
-{
-  fd_set rfd;
-  struct timeval time;
-
-  time.tv_sec = config->get_user(user->user_name).idle;
-  time.tv_usec = 0;
-
-  // We _really_ want to pass rfd as a reference...
-  FD_ZERO(&rfd);
-  FD_SET(user->socket_id, &rfd);
-  
-  if(!(select(user->socket_id + 1, &rfd, NULL, NULL, &time)))
-  {
-    if(user->data_vec.size())
-      return(false);
-    Commands::ftp_send(user, "421 Connection timed out(" + util.itos(config->get_user(user->user_name).idle) + " seconds). Disconnected.");
-    if(user->logged_in == LOGGED_IN)
-      logging->log_this(3, TYPE_AUTH, "User " + user->user_name + ", disconnected due to timeout.");
-
-    sem_wait(&user->user_lock);
-    user->logged_in = LOGGED_OUT;
-    sem_post(&user->user_lock);
-    close(user->socket_id);
-    return(false);
-  }
-  
-  char tmp_buf[210] = { 0 };
-  
-#ifdef USE_TLS
-  if(user->settings.test(TLS_ENABLED))
-    gnutls_record_recv(user->ctrl_session, static_cast<void*>(tmp_buf), 200);
-  else
-#endif // USE_TLS
-    read(user->socket_id, static_cast<void*>(tmp_buf), 200);
-  message.assign(tmp_buf, (strlen(tmp_buf)));
-  
-  if(message.size() == 2) // no need to try parsing just "\r\n"
-    return(false);
-  if(message.size() == 0)
-  {
-    // this code makes sure that we don't get stuck in an endless loop if the connection just dissapears...
-    close(user->socket_id);
-    sem_wait(&user->user_lock);
-    user->logged_in = LOGGED_OUT;
-    sem_post(&user->user_lock);
-    return(false);
-  }
-  else // everything is normal and we've got a string to play with
-    return(true);
-}
+class Commands comm;
 
 void *data_wrapper(void *void_data)
 {
   class Data *data = static_cast<class Data*>(void_data);
-  extern class Commands comm;
   string message;
-  size_t read_size = READ_SIZE; // for lack of finding a good define that fits here.
-  fd_set set; // no, it isn't a bad name, but we'll use it for both RETR and STOR
-  struct timeval timeout;
   time_t start_time = time(NULL);
   size_t trans_size = 0; // will hold the total number of sent bytes
 
-  timeout.tv_sec = 5; // same timeout for data as control? no, 5 seconds is more than enough.
-  timeout.tv_usec = 0;
-
+  data->thread_id(pthread_self());
 
   pthread_setspecific(my_data, void_data);
   pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
 
-  data->host_name = inet_ntoa(data->data_addr.sin_addr);
+  data->host_name(inet_ntoa(data->addr().sin_addr));
 
   // I don't like it, but we need to drop permissions again...
+  //   not true for new threads, need to look deeper into this.
   struct passwd pwd, *pwd_ptr;
   char pwdata[PWBUF_SIZE];
-  getpwnam_r(data->user->user_name.c_str(), &pwd, pwdata, sizeof(pwdata), &pwd_ptr);
+  getpwnam_r(data->user->user_name().c_str(), &pwd, pwdata, sizeof(pwdata),
+      &pwd_ptr);
   uid_t uid = pwd.pw_uid;
   gid_t gid = pwd.pw_gid;
   setuid(uid);
   setgid(gid);
 
-  FD_ZERO(&set);
-  FD_SET(data->data_id, &set);
-
-  sem_wait(&data->data_lock);
-  data->thread_id = pthread_self();
-  // do a dns lookup here.
-  sem_post(&data->data_lock);
-
-  if(!(select(data->data_id + 1, &set, &set, NULL, &timeout)))
-  {
-    message = "451 Data connection timed out(" + util.itos(config->get_user(data->user->user_name).idle) + " seconds).";
-    logging->log_this(3, TYPE_INFO, "User " + data->user->user_name + ", lost a data connection due to timeout.");
-  }
 #ifdef USE_TLS // handshakes etc
-  else if(data->settings.test(TLS_INITED))
-  {
-    sem_wait(&data->data_lock);
-    int ret = gnutls_handshake(data->data_session);
-    sem_post(&data->data_lock);
-    if(ret < 0) // failed handshake
-    {
-      message = "451 Failed to negotiate TLS as was asked. Closing data connection.";
-      gnutls_perror(ret);
-    }
-    else // handshake is aok
-    {
-      // tls is picky about how much in one send/recv
-      read_size = gnutls_record_get_max_size(data->data_session);
-      sem_wait(&data->data_lock);
-      data->settings.set(TLS_ENABLED);
-      sem_post(&data->data_lock);
-    }
-  }
+  if(data->settings(TLS_PROT_D))
+    if(!data->engage_tls()) // failed handshake
+      message =
+        "451 Failed to negotiate TLS as was asked. Closing data connection.";
 #endif // USE_TLS
-  while(data->data_id && message.size() == 0)
+  while(message.empty())
   {
-    char read_buf[read_size];
-    size_t size, size2;
-    if(data->settings.test(RETR_TRANS))
-      size2 = read(data->file_id, read_buf, read_size);
-
-#ifdef USE_TLS
-    if(data->settings.test(TLS_ENABLED))
-    {
-      if(data->settings.test(RETR_TRANS))
-        size = gnutls_record_send(data->data_session, read_buf, size2);
-      else // STOR_TRANS
-        size = gnutls_record_recv(data->data_session, read_buf, read_size);
+    char *read_buf = new char[data->packet_size()];
+    size_t size = 0, size2 = 0;
+    if(data->settings(RETR_TRANS))
+    {
+      size2 = read(data->file_id(), read_buf, data->packet_size());
+      if(size2 > 0)
+        size = data->send(read_buf, size2);
     }
-    else
-    {
-#endif
-      if(data->settings.test(RETR_TRANS))
-        size = write(data->data_id, read_buf, size2);
       else // STOR_STRANS
-        size = recv(data->data_id, read_buf, read_size, MSG_WAITALL);
-#ifdef USE_TLS
-    } // the else just before last #endif
-#endif
+      size = data->receive(read_buf, data->packet_size() - 1);
+
     trans_size += size;
-    if(!data->settings.test(RETR_TRANS))
+    if(!data->settings(RETR_TRANS))
     {
-      if(size != 0 && (write(data->file_id, read_buf, size) == -1))
+      if(size != 0 && (write(data->file_id(), read_buf, size) == -1))
       {
-        logging->log_this(3, TYPE_DEBUG, "Write failed to file: " + data->file_name + " from host: " + data->host_name + " with error %m");
+        logging->log_this(3, TYPE_DEBUG, "Write failed to file: " +
+            data->file_name() + " from host: " + data->host_name() +
+            " with error %m");
         message = "451 File transfer failed.";
       }
       else if(size == 0)
       {
-        if(close(data->file_id) != 0) // it's only important for STOR that the closing is proper.
+        if(close(data->file_id()) != 0)
           message = "550 Failed saving file.";
         else
           message = "226 Transfer complete.";
@@ -212,41 +79,43 @@ void *data_wrapper(void *void_data)
     {
       if(size != size2)
         message = "550 Transfer failed.";
-      else if(size2 != read_size)
+      else if(size2 != data->packet_size())
         message = "226 Transfer complete.";
     }
+    delete[] read_buf;
   }
 
-  comm.ftp_send(data->user, message);
+  *data->user << message << "\r\n";
   if(config->logger.xferlog)
   {
-    const time_t timep = time(NULL);
-    struct tm now;
-    char time_string[30] = {0};
+    string time_string;
+    util.time_string(time_string, "%a %b %d %H:%M:%S %Y ");
 
-    gmtime_r(&timep, &now);
-    strftime(time_string, 28, "%a %b %d %H:%M:%S %Y ", &now);
+    // as ' ' separates fields in the xferlog we convert them to '_' here
+    string temp_name = data->file_name();
+    for(string::iterator name_it = temp_name.begin();
+        name_it != temp_name.end(); name_it++)
+      if(isspace(*name_it))
+        *name_it = '_';
 
     // let us build a string!
     string xferlog = time_string;
     xferlog += util.itos(time(NULL) - start_time);
-    xferlog += " " + data->host_name;
+    xferlog += " " + data->host_name();
     xferlog += " " + util.itos(trans_size);
-    xferlog += " " + data->file_name + " ";
-    xferlog += (data->settings.test(BINARY)?"b":"a");
-    xferlog += " _ "; // we don't support any special-action to flag here.. or is encryption special? have to make up a flag I guess ;)
-    xferlog += (data->settings.test(RETR_TRANS)?"o":"i");
+    xferlog += " " + temp_name + " ";
+    xferlog += (data->settings(BINARY)?"b":"a");
+    xferlog += " _ "; // we don't support any special-action to flag here.
+    xferlog += (data->settings(RETR_TRANS)?"o":"i");
     xferlog += " r"; // same thing again, we only support real users so far.. 
-    xferlog += " " + data->user->user_name;
-    xferlog += " FTP"; // maybe ftps for encrypted?
+    xferlog += " " + data->user->user_name();
+    xferlog += " FTP"; // maybe ftps for encrypted? no. IANA.
     xferlog += " 0"; // there should be more auth methods available here?
     xferlog += " *"; // or should this be uid?
 
     logging->log_this(1, TYPE_XFER, xferlog);
   }
-  sem_wait(&data->user->user_lock);
-  data->user->total_transfered += trans_size;
-  sem_post(&data->user->user_lock);
+  data->user->total_transfered(data->user->total_transfered() + trans_size);
 
   pthread_exit(NULL);
 }
@@ -259,7 +128,7 @@ string Commands::parsedir(User *user, st
   string new_string;
 
   if(orig_string[0] != '/')
-    orig_string = user->current_dir + '/' + orig_string;
+    orig_string = user->current_dir() + '/' + orig_string;
 
   class StringTokenizer *token = new StringTokenizer(orig_string, "/", false);
   vector<string> dir_array;
@@ -286,58 +155,39 @@ string Commands::parsedir(User *user, st
   if(dir_array.empty())
     new_string = '/';
   else
-    for(vector<string>::iterator dir_it = dir_array.begin(); dir_it != dir_array.end(); dir_it++)
+    for(vector<string>::iterator dir_it = dir_array.begin();
+        dir_it != dir_array.end(); dir_it++)
       new_string += '/' + *dir_it;
 
-  if(user->root_dir.size() > 1)
-    if(new_string.find(user->root_dir) != 0)
-      new_string = user->root_dir + new_string;
+  if(user->root_dir().size() > 1)
+    if(new_string.find(user->root_dir()) != 0)
+      new_string = user->root_dir() + new_string;
 
 
   return(new_string);
 }
 
-#ifdef USE_TLS
-
-void Commands::init_tls(gnutls_session &session)
-{
-  gnutls_init(&session, GNUTLS_SERVER);
-
-  gnutls_set_default_priority(session);   
-
-  gnutls_credentials_set(session, GNUTLS_CRD_CERTIFICATE, x509_cred);
-
-  gnutls_certificate_server_set_request(session, GNUTLS_CERT_REQUEST);
-
-  gnutls_dh_set_prime_bits(session, 1024);
-
-  gnutls_db_set_retrieve_function(session, tls_db_fetch);
-  gnutls_db_set_remove_function(session, tls_db_delete);
-  gnutls_db_set_store_function(session, tls_db_store);
-  gnutls_db_set_ptr(session, NULL);
-}
-#endif // USE_TLS
-
 int pam_conversate(int num_msg, const struct pam_message **msg,
     struct pam_response **resp, void *appdata_ptr)
 {
-  struct pam_response *reply = new struct pam_response[0];
+  struct pam_response *reply = NULL;
   int count = 0;
   struct pam_data *auth_data = (static_cast<struct pam_data*>(appdata_ptr));
 
   for(int i = 0; i < num_msg; i++)
   {
+    struct pam_response *reply_tmp;
     switch(msg[i]->msg_style)
     {
       case PAM_PROMPT_ECHO_ON:
       case PAM_PROMPT_ECHO_OFF:
-        if(count != 0)
-        {
-          struct pam_response *reply_tmp = new struct pam_response[count + 1];
+        reply_tmp = (static_cast<struct pam_response*>
+            (malloc(sizeof(struct pam_response) * (count + 1))));
           memcpy(reply_tmp, reply, count);
-          delete[] reply;
+        if(reply)
+          free(reply);
           reply = reply_tmp;
-        }
+
         // is this really how it should be done?
         if(msg[i]->msg_style == PAM_PROMPT_ECHO_ON)
           reply[i].resp = strndup(auth_data->user_name.c_str(),
@@ -354,7 +204,8 @@ int pam_conversate(int num_msg, const st
 
       case PAM_ERROR_MSG:
       default:
-        delete[] reply;
+        if(reply)
+          free(reply);
         return PAM_CONV_ERR;
     }
   }
Index: Commands.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Commands.h,v
retrieving revision 1.80
diff -u -p -b -r1.80 Commands.h
--- Commands.h	22 Jan 2005 17:18:50 -0000	1.80
+++ Commands.h	10 Apr 2005 22:43:18 -0000
@@ -1,117 +1,113 @@
 /////////////////////////////////////////////////////////////////////
-//  File: Commands.h
+// $Id: Commands.h,v 1.95 2005/04/05 12:45:07 jockelundin Exp $
 // Usage: Ftp commands and data transfer functions
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __COMMANDS_H__
-#define __COMMANDS_H__
+#ifndef COMMANDS_H
+#define COMMANDS_H
 
-#if (defined(__COMMANDS_CPP__) || defined(__COMMANDS2_CPP__))
+#if (defined(COMMANDS_CPP) || defined(COMMANDS2_CPP))
 #include "generic.h"
-#include "User.h"
 #include "Utilities.h"
 #include "Configuration.h"
+#include "Log.h"
+#include "Connection.h"
+#include "Data.h"
+#include "User.h"
 #include "Handler.h"
 #include "StringTokenizer.h"
-#include "Log.h"
 #endif
 
+#define BABY_COM(com)  bool com(User *user, string argument, unsigned int flag)
+
 class Commands
 {
   private:
     string parsedir(User*, string);
-    string mod_time(struct stat);
     string mlsx(User*, string);
     string list_file(string);
     string mlst_string(User*);
   public:
-    bool user(User*, string, unsigned int);
-    bool pass(User*, string, unsigned int);
-    bool retr(User*, string, unsigned int);
-    bool stor(User*, string, unsigned int);
-    bool port(User*, string, unsigned int);
-    bool quit(User*, string, unsigned int);
-    bool list(User*, string, unsigned int);
-    bool help(User*, string, unsigned int);
-    bool mkd(User*, string, unsigned int);
-    bool rmd(User*, string, unsigned int);
-    bool cwd(User*, string, unsigned int);
-    bool dele(User*, string, unsigned int);
-    bool pasv(User*, string, unsigned int);
-    bool ftp_send(User*, string);
-    bool ftp_receive(User*, string&);
-    bool rname(User*, string, unsigned int);
-    bool opts(User*, string, unsigned int);
-    bool rest(User*, string, unsigned int);
-    bool abor(User*, string, unsigned int);
+    BABY_COM(user);
+    BABY_COM(pass);
+    BABY_COM(retr);
+    BABY_COM(stor);
+    BABY_COM(port);
+    BABY_COM(quit);
+    BABY_COM(list);
+    BABY_COM(help);
+    BABY_COM(mkd);
+    BABY_COM(rmd);
+    BABY_COM(cwd);
+    BABY_COM(dele);
+    BABY_COM(pasv);
+    BABY_COM(rname);
+    BABY_COM(opts);
+    BABY_COM(rest);
+    BABY_COM(abor);
     // functions for simple commands that don't justify an own function
-    bool sim1(User*, string, unsigned int);
-    bool sim2(User*, string, unsigned int);
+    BABY_COM(sim1);
+    BABY_COM(sim2);
     sem_t pam_lock; // pam is not threadsafe.
 #ifdef USE_TLS
     // collection of encryption commands
-    bool auth(User*, string, unsigned int);
-    void init_tls(gnutls_session&);
+    BABY_COM(auth);
 #endif // USE_TLS
 };
 
+extern class Commands comm;
+
 // the extra flags we can play with...
-#define COM_LONG (1 << 0)  // for list()
-#define COM_SHORT (1 << 1) 
-#define COM_MLSD (1 << 2)
-
-#define COM_FROM (1 << 0) // for rname()
-#define COM_TO (1 << 1)
-
-#define COM_STOR (1 << 0) // for stor()
-#define COM_APPE (1 << 1)
-
-#define COM_CDUP (1 << 0)
-#define COM_CWD  (1 << 1)
-
-#define COM_NOOP (1 << 0) // for sim1()
-#define COM_PWD  (1 << 1)
-#define COM_SYST (1 << 2)
-#define COM_FEAT (1 << 3)
-#define COM_TYPE (1 << 4)
-#define COM_MODE (1 << 5)
-#define COM_STRU (1 << 6)
+const int COM_LONG = (1 << 0);  // for list()
+const int COM_SHORT = (1 << 1);
+const int COM_MLSD = (1 << 2);
+
+const int COM_FROM = (1 << 0); // for rname()
+const int COM_TO = (1 << 1);
+
+const int COM_STOR = (1 << 0); // for stor()
+const int COM_APPE = (1 << 1);
+
+const int COM_CDUP = (1 << 0);
+const int COM_CWD  = (1 << 1);
+
+const int COM_NOOP = (1 << 0); // for sim1()
+const int COM_PWD  = (1 << 1);
+const int COM_SYST = (1 << 2);
+const int COM_FEAT = (1 << 3);
+const int COM_TYPE = (1 << 4);
+const int COM_MODE = (1 << 5);
+const int COM_STRU = (1 << 6);
 #ifdef USE_TLS
-#define COM_PBSZ (1 << 7)
-#define COM_PROT (1 << 8)
-#define COM_CCC  (1 << 9)
-#define COM_CONF (1 << 10)
-#define COM_MIC (1 << 11)
-#define COM_ENC (1 << 12)
+const int COM_PBSZ = (1 << 7);
+const int COM_PROT = (1 << 8);
+const int COM_CCC  = (1 << 9);
+const int COM_CONF = (1 << 10);
+const int COM_MIC = (1 << 11);
+const int COM_ENC = (1 << 12);
 #endif // USE_TLS
 
-#define COM_SIZE (1 << 0) // for sim2()
-#define COM_MDTM (1 << 1)
-#define COM_MLST (1 << 2)
-
-#define COM_PORT (1 << 0) // port and pasv
-#define COM_EPRT (1 << 1)
-#define COM_PASV (1 << 2)
-#define COM_EPSV (1 << 3)
-
-#define BEFORE_USER (1 << 31) // remember that these are used in conunctions with those above..
-#define LAST_COM (1 << 30)
+const int COM_SIZE = (1 << 0); // for sim2()
+const int COM_MDTM = (1 << 1);
+const int COM_MLST = (1 << 2);
+
+const int COM_PORT = (1 << 0); // port and pasv
+const int COM_EPRT = (1 << 1);
+const int COM_PASV = (1 << 2);
+const int COM_EPSV = (1 << 3);
 
-#define PROT_IPV4 1 // EPRT and EPSV
-#define PROT_IPV6 2
+// remember that these are used in conunctions with those above..
+const int BEFORE_USER = (1 << 31);
 
-#define READ_SIZE 16384
+const int PROT_IPV4 = 1;// EPRT and EPSV
+const int PROT_IPV6 = 2;
 
-#define PWBUF_SIZE 100
 
 void *data_wrapper(void*) __attribute__ ((noreturn));
 
-extern class Configuration *config;
-extern class Utilities util;
-extern class Handler handler;
 extern vector<User*> user_list;
 
 #ifdef USE_TLS
